//A PRI Table handler
class DTHandler expands DHandler
	config(DCoopDataTable);

struct TMessage
{
var int Sender;
var string Message;
var string TimeStamp;
};

struct TEntry
{
var string Pass;
var int Deaths;
var int Score;
var int DScore;
var int Spree;
var int DmgPts;
var int ULvl;
var float TotalPlayed;
var string UName;
var string Inv;
var string LastName;
var string Mail;
/*
Int-NumMessages
Del-;
/ for each message /
Int-Sender
Del-,
String-Message [HEX Encrypted]
Del-,
String-TimeStamp
Del-;
/ for each message /
*/
};

var config TEntry Data[4096];
var TMessage _Mail[16];
var(Parameters) config bool bNotPermanentInvs;

function string GChar(string _In, int _Ind)
{
return Mid(_In,_Ind,1);
}

function string SITH(int _InSI)
{
switch (_InSI) {
case 0: case 1: case 2: case 3: case 4: case 5: case 6: case 7: case 8: case 9: return string(_InSI);
case 10: return "A"; break; case 11: return "B"; break; case 12: return "C"; break;
case 13: return "D"; break; case 14: return "E"; break; case 15: return "F"; break;
} return "~";
}

function int HTSI(string _In)
{
switch (_In) {
case "0": case "1": case "2": case "3": case "4": case "5": case "6": case "7": case "8": case "9": return int(_In);
case "A": return 10; break; case "B": return 11; break; case "C": return 12; break;
case "D": return 13; break; case "E": return 14; break; case "F": return 15; break;
} return -1;
}

function string HexEncr(string _In)
{
local string Res;
local string PChar;
local string PHex;
local int PreHex;
local float Tmp;
local float Tmp2;
local int I;
Res="";
for(I=0;I<Len(_In);I++)
{
PChar=GChar(_In,I);
PreHex=Asc(PChar);
Tmp=PreHex/16;
Tmp2=PreHex-(Int(Tmp)*16);
Tmp=Int(Tmp);
PHex=SITH(Tmp)$SITH(Tmp2);
Res=Res$PHex;
}
return Res;
}

function string HexDecr(string _In)
{
local string Res;
local string PChar;
local int Tmp1, Tmp2;
local int PreChar;
local string PC1, PC2;
local int I;
Res="";
if (Int(Float(Len(_In)/2))!=Len(_In)/2) return "Bad String";
for(I=0;I<Len(_In);I+=2)
{
PC1=GChar(_In,I);
PC2=GChar(_In,I+1);
Tmp1=HTSI(PC1);
Tmp2=HTSI(PC2);
PreChar=Tmp1*16+Tmp2;
PChar=Chr(PreChar);
Res=Res$PChar;
}
return Res;
}

function EncryptMail(int Id)
{
local string S;
local int I,N;
/* Encrypt _Mail, put to Data[Id].Mail */
S="";
N=0;
for (I=0;I<16;I++)
	{
	if (_Mail[I].Sender!=0)
		{
		N++;
		S=S$_Mail[I].Sender$","$HexEncr(_Mail[I].Message)$","$_Mail[I].TimeStamp$";";
		}
	_Mail[I].Message="";
	_Mail[I].Sender=0;
	_Mail[I].TimeStamp="";
	}
S=N$";"$S;
Data[Id].Mail=S;
}

function DecryptMail(int Id)
{
local string S,M;
local int N,I,L;
/* Decrypt Data[Id].Mail, put to _Mail */
for (I=0;I<16;I++) { _Mail[I].Message=""; _Mail[I].Sender=0; _Mail[I].TimeStamp=""; }
S=Data[Id].Mail;
N=int(Left(S,InStr(S,";"))); S=Mid(S,InStr(S,";")+1);
for (I=0;I<N;I++)
	{
	M=Left(S,InStr(S,";")); S=Mid(S,InStr(S,";")+1);
	_Mail[I].Sender=int(Left(M,InStr(M,","))); M=Mid(M,InStr(M,",")+1);
	_Mail[I].Message=HexDecr(Left(M,InStr(M,","))); M=Mid(M,InStr(M,",")+1);
	_Mail[I].TimeStamp=M;
	}
}

function string TwoDig(int Dig)
{
if (Len(string(Dig))>2) Dig=Int(Right(String(Dig),2));
if (Dig<0) return "00";
if (Dig<10) return "0"$Dig;
	else return string(Dig);
}

function string ThreeDig(int Dig)
{
if (Len(string(Dig))>3) Dig=Int(Right(String(Dig),3));
if (Dig<0) return "000";
if (Dig<10) return "0"$Dig;
if (Dig<100) return "0"$Dig;
	else return string(Dig);
}

function DataList(DPlayer SPlayer, string Mask, int MinRange, int MaxRange)
{
	local int I;
	SPlayer.RecvMsg(None,"DataList result: ",'Error',True);
	if (Mask!="")
	{
	for (I=0;I<4096;I++)
		if (Data[I].Pass!="")
			if (MaskedCompare(HexDecr(Data[I].LastName),Mask,False))
				SPlayer.RecvMsg(None,"#"$I$": "$HexDecr(Data[I].LastName),'ServerEvent',False);
	}
	else
	{
	if (MaxRange<MinRange) return;
	for (I=MinRange;I<MaxRange;I++)
		if (Data[I].Pass!="")
			SPlayer.RecvMsg(None,"#"$I$": "$HexDecr(Data[I].LastName),'ServerEvent',False);
	}
	SPlayer.RecvMsg(None,"Use console to see returned list",'Error',True);
}

function SendMessage(DPlayer SPlayer, int Sender, int Receiver, string Msg)
{
	local int I;
	Log("SendMessage from "$Sender$" to "$Receiver$": "$Msg);
	DecryptMail(Receiver);
	for (I=0;I<16;I++)
		if (_Mail[I].Sender==Sender)
			{
			SPlayer.RecvMsg(None,"Anti-Spam: You are not allowed to send more then one to this player. If you need to do that, revoke your first message first.",'Error',True);
			return;
			}
	for (I=0;I<16;I++)
		if (_Mail[I].Sender==0)
			{
			_Mail[I].Message=Msg;
			_Mail[I].Sender=Sender;
			_Mail[I].TimeStamp=TwoDig(Level.Day)$TwoDig(Level.Month)$TwoDig(Level.Year)$TwoDig(Level.Hour)$TwoDig(Level.Minute)$TwoDig(Level.Second);
			EncryptMail(Receiver);
			SPlayer.RecvMsg(None,HexDecr(Data[Receiver].LastName)$" have successfully received your message.",'Error',True);
			return;
			}
}

function RevokeMessage(DPlayer SPlayer, int Sender, int Receiver)
{
	local int I;
	DecryptMail(Receiver);
	for (I=0;I<16;I++)
		if (_Mail[I].Sender==Sender)
		{
		_Mail[I].Sender=0;
		_Mail[I].TimeStamp="";
		_Mail[I].Message="";
		SPlayer.RecvMsg(None,"Successfully revoked your message from "$HexDecr(Data[Receiver].LastName)$".",'Error',True);
		EncryptMail(Receiver);
		return;
		}
	SPlayer.RecvMsg(None,"Failed to revoke message (No your messages)",'Error',True);
	return;
}

function int MessageCount(DPlayer SPlayer)
{
	local int I,N;
	DecryptMail(SPlayer.myPRI.DHandle);
	N=0;
	for (I=0;I<16;I++)
		if (_Mail[I].Sender!=0)
			N++;
	return N;
}

function string DTS(string S)
{
return "["$Mid(S,0,2)$"\\"$Mid(S,2,2)$"\\"$Mid(S,4,2)$" - "$Mid(S,6,2)$":"$Mid(S,8,2)$":"$Mid(S,10,2)$"]";
}

function MessageList(DPlayer SPlayer)
{
	local int I,H;
	local string S;
	SPlayer.RecvMsg(None,"Inbox:",'ServerEvent',True);
	H=SPlayer.myPRI.DHandle;
	DecryptMail(H);
	for (I=0;I<16;I++)
	{
	S="#"$(I+1)$": ";
	if (_Mail[I].TimeStamp!="")
		S=S$DTS(_Mail[I].TimeStamp);
	else
		S=S$"<No";
	if (_Mail[I].Sender!=0)
		{
		S=S$" Message by ";
		S=S$HexDecr(Data[_Mail[I].Sender].LastName);
		}
	else
		S=S$" message>";
	SPlayer.RecvMsg(None,S,'ServerEvent',False);
	}
	SPlayer.RecvMsg(None,"Use console to view your messages list",'Error',True);
}

function MessageShow(DPlayer SPlayer, int MsgNum)
{
	local int H;
	H=SPlayer.myPRI.DHandle;
	DecryptMail(H);
	MsgNum--;
	if ((MsgNum<0)||(MsgNum>15)) { SPlayer.RecvMsg(None,"Range error: 1 > MsgNum > 16",'Error',True); return; }
	SPlayer.RecvMsg(None,"Message #"$(MsgNum+1),'ServerEvent',False);
	SPlayer.RecvMsg(None,"Sent at: "$DTS(_Mail[MsgNum].TimeStamp),'ServerEvent',False);
	SPlayer.RecvMsg(None,"Sender Ident: "$_Mail[MsgNum].Sender,'ServerEvent',False);
	SPlayer.RecvMsg(None,"Sender: "$HexDecr(Data[_Mail[MsgNum].Sender].LastName),'ServerEvent',False);
	SPlayer.RecvMsg(None,_Mail[MsgNum].Message,'ServerEvent',False);
	SPlayer.RecvMsg(None,"Please read message in console",'Error',True);
}

function MessageDel(DPlayer SPlayer, int MsgNum)
{
	local int H;
	H=SPlayer.myPRI.DHandle;
	DecryptMail(H);
	MsgNum--;
	if ((MsgNum<0)||(MsgNum>15)) { SPlayer.RecvMsg(None,"Range error: 1 > MsgNum > 16",'Error',True); return; }
	if (_Mail[MsgNum].Sender==0)
	{ SPlayer.RecvMsg(None,"Message does not exist",'Error',True); return; }
	_Mail[MsgNum].Message="";
	_Mail[MsgNum].Sender=0;
	_Mail[MsgNum].TimeStamp="";
	SPlayer.RecvMsg(None,"Message deleted successfully",'Error',True);
	EncryptMail(H);
}

function NotifyEndGame(bool bQuit)
{
	SaveConfig();
}

event PostBeginPlay()
{
	super.PostBeginPlay();
	SetTimer(10,True);
}

event Timer()
{
	super.Timer();
//	SaveConfig();
}

event Tick(float Delta)
{
	super.Tick(Delta);
	if (bDeleteMe)
		SaveConfig();
}

event Destroyed()
{
	super.Destroyed();
	SaveConfig();
}

function ProcessPassword(DPRI PRI, DPlayer PP, string Pass)
{
	local int I, C, E;
	C=0; E=0;
	if (Len(Pass)!=32)
	{
	DCoop(Level.Game).BrMsg(PRI.PlayerName$" was kicked because of an Invalid UniqueID",'ServerEvent',False);
	PP.bKicked=True;
	PP.Destroy();
	return;
	}
	for (I=1;I<4096;I++)
		{
		if ((E==0)&&(Data[I].Pass==""))
			E=I; /* An empty slot */
		if ((C==0)&&(Data[I].Pass==Pass))
			{
			/* Thats what i needed! */
			C=I;
			break;
			}
		}
	if ((C==0)&&(E>0))
	{
		/* Create a new DataTable entry */
		C=E;
		Data[C].Pass=Pass;
		PRI.DHandle=C; /* What a stupid bug... BSBSBS */
		/* Well this guy joined first time, what else do ya want?! */
		PRI.bAcked=True; /* Acknowledged! */
		return;
	}
	if (C==0) return; /* Yet... */
	PRI.Deaths=Data[C].Deaths;
	PRI.DScore=Data[C].DScore;
	PRI.Score=float(Data[C].Score);
	PRI.KSpree=Data[C].Spree;
	PRI.DmgPts=Data[C].DmgPts;
	PRI.UserName=Data[C].UName;
	PRI.UserLvl=Data[C].ULvl;
	if (PRI.UserLvl>2)
		PlayerPawn(PRI.Owner).bAdmin=True;
	if (!bNotPermanentInvs)
		GiveInventory(PRI,C);
	PRI.DHandle=C; /* Important for data saving */
	PRI.bAcked=True; /* Acknowledged! */
	/* Alrite, we restored this player's shit */
}

function GiveInventory(DPRI PRI, int C)
{
	local string S,P;
	local int pos;
	local inventory Inv;
	for (Inv=PRI.Owner.Inventory;Inv!=None;Inv=Inv.Inventory)
		Inv.Destroy();
	PRI.Owner.Inventory=None;
	if (PRI.Owner.IsA('DPlayer'))
	DPlayer(PRI.Owner).bDontRecvPickup=True;
	S=Data[C].Inv;
	if ( S != "" )
	{
		while ( S != "" )
		{
			pos = InStr(S,";");
			if ( pos > 0 )
			{
				P = Left(S, pos);
				S = Right(S, Len(S) - pos - 1);
			}
			else
			{
				P = S;
				S = "";
			}
			if (Left(P,1)=="1") GiveItem(PRI,Mid(P,1));
			if (Left(P,1)=="2") GiveWeapon(PRI,Mid(P,1));
			if (Left(P,1)=="3") SelectItem(PRI,Mid(P,1));
			if (Left(P,1)=="4") SelectWeapon(PRI,Mid(P,1));
		}
	}
	if (PRI.Owner.IsA('DPlayer'))
	DPlayer(PRI.Owner).bDontRecvPickup=False;
}

function SelectItem(DPRI PRI, string ItemCla)
{
	local inventory I;
	if (DPlayer(PRI.Owner)!=None)
	for (I=PRI.Owner.Inventory;I!=None;I=I.Inventory)
	if (String(I.Class)~=ItemCla)
	DPlayer(PRI.Owner).SelectedItem=I;
}

function SelectWeapon(DPRI PRI, string ItemCla)
{
	local inventory I;
	if (DPlayer(PRI.Owner)!=None)
	for (I=PRI.Owner.Inventory;I!=None;I=I.Inventory)
	if (String(I.Class)~=ItemCla)
	{
	DPlayer(PRI.Owner).Weapon=Weapon(I);
	Weapon(I).BringUp();
	return;
	}
}

function int BtI(bool B) {if (B) return 1; else return 0;}
function bool ItB(int I) {return (I!=0);}

function GiveItem(DPRI PRI, string S)
{
	local class<Inventory> IC;
	local inventory Inv;
	local DPlayer PP;
	local string P,IN;
	PP=DPlayer(PRI.Owner);
	if (PP==None) return;

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries class */
	IC=class<Inventory>(DynamicLoadObject(P,class'Class'));
	if (IC==None) return; Inv=GiveIt(PP,IC); if (Inv==None) return;

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries charge */
	if (int(P)>0) Inv.Charge=Int(P);

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries bActive */
	//Inv.bActive=ItB(int(P));
	if (ItB(int(P)))
		{
		P=Inv.M_Activated; IN=Inv.ItemName;
		Inv.Activate();
		Inv.M_Activated=P; Inv.ItemName=IN;
		}

	/* S now carries NumCopies \ ASW */
	if (Inv.IsA('Pickup'))
	Pickup(Inv).NumCopies=int(S);
	else
	Inv.AutoSwitchPriority=int(S);
}

function GiveWeapon(DPRI PRI, string S)
{
	local class<Weapon> IC;
	local weapon Inv;
	local DPlayer PP;
	local string P,IN,M;
	PP=DPlayer(PRI.Owner);
	if (PP==None) return;

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries class */
	IC=class<weapon>(DynamicLoadObject(P,class'Class'));
	if (IC==None) return; Inv=Weapon(GiveIt(PP,IC)); if (Inv==None) return;

	Inv.PickupAmmoCount=0;
	Inv.GiveAmmo(PP);
	Inv.PickupAmmoCount=Inv.Default.PickupAmmoCount;

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries Ammo Amount */
	if (int(P)>0) Inv.AmmoType.AmmoAmount=Int(P);

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries Max Ammo Amount */
	if (int(P)>0) Inv.AmmoType.MaxAmmo=Int(P);

	P=Left(S,InStr(S,"|")); S=Right(S,Len(S)-InStr(S,"|")-1);
	/* P now carries bActive */
	if (ItB(int(P)))
		{
		M=Inv.M_Activated; IN=Inv.ItemName;
		Inv.Activate();
		Inv.M_Activated=M; Inv.ItemName=IN;
		}

	/* S now carries AutoSwitchPriority */
	if (!Inv.IsA('DispersionPistol'))
		Inv.AutoSwitchPriority=int(S);
	else
		DispersionPistol(Inv).PowerLevel=int(S);
}

function inventory GiveIt( Pawn PP, class<Inventory> IClass )
{
	local inventory Inv;
	local int I;
	local bool bCWP, bCW;

	bCWP=IClass.Default.bCollideWhenPlacing;
	bCW=IClass.default.bCollideWorld;

	IClass.Default.bCollideWhenPlacing = False;
	IClass.Default.bCollideWorld = False;

	Inv = Spawn( IClass,PP,'',PP.Location,PP.Rotation );

	IClass.Default.bCollideWhenPlacing = bCWP;
	IClass.Default.bCollideWorld = bCW;

	if( Inv==None )
		return None;
		/* That sucks. */

	Inv.SetCollision(False,False,False);
	Inv.PickupMessage=""; Inv.PickupSound=None;
	Inv.bHeldItem=True;	Inv.Touch(PP);
	Inv.PickupMessage=Inv.Default.PickupMessage;
	Inv.PickupSound=Inv.Default.PickupSound;

	If( Inv.GetStateName() == 'Sleeping' || Inv.GetStateName() == 'Pickup' ||
		Inv.GetStateName()==Inv.InitialState 								  )
		Inv.Destroy();

	return Inv;
}

function UpdUser(string UserName, int UserLevel)
{
	local int I;
	for (I=0;I<4096;I++)
	if (Data[I].UName==UserName)
		Data[I].ULvl=UserLevel;
}

function DelUser(string UserName)
{
	local int I;
	for (I=0;I<4096;I++)
	if (Data[I].UName==UserName)
	{
	Data[I].ULvl=0;
	Data[I].UName="";
	}
}

function UpdateData(DPRI PRI, float Delta)
{
	local string S;
	local inventory I;
	Data[PRI.DHandle].Deaths=PRI.Deaths;
	Data[PRI.DHandle].DScore=PRI.DScore;
	Data[PRI.DHandle].Score=int(PRI.Score);
	Data[PRI.DHandle].Spree=PRI.KSpree;
	Data[PRI.DHandle].DmgPts=PRI.DmgPts;
	Data[PRI.DHandle].ULvl=PRI.UserLvl;
	Data[PRI.DHandle].UName=PRI.UserName;
	S="";
	if (!bNotPermanentInvs)
	{
	if (DPlayer(PRI.Owner)!=None)
	{
	for (I=PRI.Owner.Inventory;I!=None;I=I.Inventory)
	if (!I.IsA('Ammo')) /* They are stored in weapon data */
	{
	if (I.IsA('Weapon'))
		S=S$"2";
	else
		S=S$"1";
	S=S$I.Class$"|";
	if (I.IsA('Weapon'))
	{
	if (Weapon(I).AmmoType!=None)
		S=S$Weapon(I).AmmoType.AmmoAmount$"|"$Weapon(I).AmmoType.MaxAmmo$"|";
	else
		S=S$Weapon(I).default.PickupAmmoCount$"|"$Weapon(I).default.AmmoName.default.MaxAmmo$"|";
	}
	else
		S=S$I.Charge$"|";
	if (I.IsA('Pickup'))
	S=S$BtI(I.bActive)$"|"$Pickup(I).NumCopies$";";
	else if (I.IsA('DispersionPistol'))
	S=S$BtI(I.bActive)$"|"$DispersionPistol(I).PowerLevel$";";
	else
	S=S$BtI(I.bActive)$"|"$I.AutoSwitchPriority$";";
	}
	if (DPlayer(PRI.Owner).SelectedItem!=None)
		S=S$"3"$DPlayer(PRI.Owner).SelectedItem.Class$";";
	if (DPlayer(PRI.Owner).Weapon!=None)
		S=S$"4"$DPlayer(PRI.Owner).Weapon.Class$";";
	}
	}
	Data[PRI.DHandle].Inv=S;
	Data[PRI.DHandle].LastName=HexEncr(PRI.PlayerName);
	Data[PRI.DHandle].TotalPlayed+=Delta;
}

defaultproperties
{
				bNotPermanentInvs=True
}
